/* Data structure definitionz for ICAO MRZ */

#ifndef MRTD_MRZ_H
#define MRTD_MRZ_H

/* this data structure describes the machine readable zone of ICAO Doc 9303
 * machine readable travel documents */
struct mrtd_mrz_info {
	char doctype[2];
	char issuing_state[3];
	union {
		struct {
			char name[30];		/* ID-1:30 ID-2:31, ID-3:39 */
			char docnr[9];		/* FIXME: can be extended !! */
			char docnr_check;
			char nationality[3];
			char date_of_birth[6];
			char date_of_birth_check;
			char sex;
			char date_of_expiry[6];
			char date_of_expiry_check[1];
			char optional_data[26];
		} id1;
		struct {
			char name[31];
			char docnr[9];		/* FIXME: can be extended !! */
			char docnr_check;
			char nationality[3];
			char date_of_birth[6];
			char date_of_birth_check;
			char sex;
			char date_of_expiry[6];
			char date_of_expiry_check[1];
			char optional_data[7];
		} id2;
		struct {
			char name[39];
			char docnr[9];		/* FIXME: can be extended !! */
			char docnr_check;
			char nationality[3];
			char date_of_birth[6];
			char date_of_birth_check;
			char sex;
			char date_of_expiry[6];
			char date_of_expiry_check;
			char optional_data[14];
			char optional_data_check;
		} id3;
	}
	char check_digit_total[1];
} __attribute__ ((packed));


#endif /* MRTD_MRZ_H */
