/* Active Authentication for ICAO-compliant MTRD's 
 *
 * (C) 2005 by Harald Welte <laforge@hmw-consulting.de>
 *
 */ 
#include <string.h>
#include <string.h>

#include <libmrtd/icao.h>

#include <openssl/rand.h>

#include "iso7816_util.h"

#define K_PU_AA_LEN	2048

int
mrtd_active_authentication(struct mrtd_handle *h)
{
	unsigned char k_pu_aa[K_PU_AA_LEN];
	unsigned int k_pu_aa_len = sizeof(k_pu_aa);
	unsigned char rnd_ifd[8];
	unsigned char cmd[5+sizeof(rnd_ifd)];
	unsigned char resp[256];
	unsigned int resp_len = sizeof(resp);

	int rv;

	/* read KpuAA from chip.  LDS/PKI specs say where it's DG15 */
	rv = iso7816_read_ef(h, ICAO_LDS_FID_DG15, k_pu_aa, &k_pu_aa_len);
	if (rv < 0)
		return rv;

	/* FIXME: parse TLV, calc hash, verify hash with EF.SOD */


	rv = RAND_bytes((unsigned char *)rnd_ifd, sizeof(rnd_ifd));
	if (rv != 1)
		return -1;

	cmd[0] = 0x00;
	cmd[1] = 0x88;
	cmd[2] = 0x00;
	cmd[3] = 0x00;
	cmd[4] = sizeof(rnd_ifd);
	memcpy(cmd+5, rnd_ifd, sizeof(rnd_ifd));

	rv = h->fn.transceive(h, cmd, sizeof(cmd), resp, &resp_len);
	if (rv < 0)
		return rv;

	/* FIXME: verify signature contained in response */
	return -1;


	return 0;
}

