#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <libmrtd/iso19794_5.h>

void
mrtd_display_dg2(struct iso19794_5_info *dg2_info)
{
	int i;

	printf("%d facial image(s) found\n", dg2_info->frh.num_images);
	for (i = 0; i < dg2_info->frh.num_images; i++) {
		struct mrtd_facial_record *fr = &dg2_info->fr[i];
		u_int32_t feature_mask = 
			*((u_int32_t*) fr->facial_info.feature_mask) & 0xffffff;
		char fname[64];
		int fd;


		printf("Image %d:\n", i);
		printf("\tGender: %s\n",
			iso19794_5_gender(fr->facial_info.gender));
		printf("\tEye colour: %s\n",
			iso19794_5_eye_colour(fr->facial_info.eye_colour));
		printf("\tHair colour: %s\n",
			iso19794_5_hair_colour(fr->facial_info.hair_colour));
		printf("\tFeatures: %s\n", iso19794_5_features(feature_mask));
		printf("\tExpression: %s\n", 
			iso19794_5_expression(fr->facial_info.expression));

		printf("\tType: %s\n",
			iso19794_5_img_type(fr->image_info.image_type));
		printf("\tWidth: %u, Height: %u\n",
			fr->image_info.width, fr->image_info.height);
		printf("\tData Type: %s\n",
			iso19794_5_img_data_type(fr->image_info.data_type));
		printf("\tColour Space: %s\n",
			iso19794_5_img_cspace(fr->image_info.cspace));
		printf("\tSource: %s\n",
			iso19794_5_img_source(fr->image_info.source_type));
		printf("\tDevice: %u\n", fr->image_info.device_type);
		printf("\tQuality: %u\n", fr->image_info.quality);

		printf("\tFile Size: %u\n", fr->image_data_len);
	}
}

