#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <libmrtd/icao.h>
#include <libmrtd/libmrtd.h>
#include <libmrtd/iso19794_5.h>

int mrtd_dump(struct mrtd_handle *ih)
{
	int i;
	int fd;
	char fname[32];

	/* All DG's in raw format */
	for (i = 0; i < 16; i++) {
		if (!ih->ef[i].data || !ih->ef[i].len)
			continue;
		
		sprintf(fname, "DG%u.raw", i);
		fd = creat(fname, S_IRUSR|S_IWUSR);
		if (fd < 0)
			continue;
		write(fd, ih->ef[i].data, ih->ef[i].len);
		close(fd);
	}

	/* All photographs from DG2 */
	for (i = 0; i < ih->dg2_info->frh.num_images; i++) {
		struct mrtd_facial_record *fr = &ih->dg2_info->fr[i];

		sprintf(fname, "DG2_%u.jpg", i);
		fd = creat(fname, S_IRUSR|S_IWUSR);
		if (fd < 0)
			continue;
		write(fd, fr->image_data, fr->image_data_len);
		close(fd);
	}

	return 0;
}
