#ifndef _TLV_H
#define _TLV_H

typedef u_int32_t tlvlen_t;

typedef struct tlv {
	/* internal state */
	unsigned char *_tagptr;
	unsigned char *_lenptr;		/* pointer to 'len' field */
	unsigned int _len;		/* 'outer' length, specified by user */

	/* parsed information */
	u_int16_t tag;			/* parsed tag */
	tlvlen_t len;			/* number of octets */
	unsigned char *val;		/* octet string */
} tlv_t;

extern int tlv_parse(const unsigned char *data, int len, struct tlv *tlv);
extern u_int16_t tlv_raw_tag(const struct tlv *t);
extern tlvlen_t tlv_gross_len(const struct tlv *t);

extern int tlv_parse_first_child(const struct tlv *parent, struct tlv *tlv);
extern int
tlv_parse_next_child(const struct tlv *parent, const struct tlv *prev, struct tlv *tlv);

extern int
tlv_build_tl(unsigned char *dst, unsigned int raw_tag, unsigned int len);

extern int
tlv_build(unsigned char *dst, const unsigned char *src, unsigned int raw_tag, unsigned int len);
#endif
