/* libmtrd OpenCT backend */
#ifdef _HAVE_OPENCT

#include <libmrtd/icao.h>
#include <openct/openct.h>

int
transceive_openct(struct mrtd_handle *h,
		  const unsigned char *cmd, unsigned int len,
		  unsigned char *resp, unsigned int *rlen)
{
	int rv;
	
	rv = ct_card_transact(h->transp.openct.handle, h->transp.openct.slot,
			      cmd, len, resp, *rlen);
	if (rv <= 0)
		return -1;

	*rlen = rv;

	return 0;
}

int 
mrtd_openct_init(struct mrtd_handle *h)
{
	h->fn.transceive = transceive_openct;

	h->transp.openct.handle = ct_reader_connect(0);
	h->transp.openct.slot = 0;

	return 0;
}

#endif
