/* libmtrd PC/SC backend */
#ifdef _HAVE_PCSC

#include <libmrtd/icao.h>

#include <winscard.h>
#include <pcsclite.h>

int
transceive_pcsc(struct mrtd_handle *h,
		const unsigned char *cmd, unsigned int len,
		unsigned char *resp, unsigned int *rlen)
{
	unsigned long _rlen = *rlen;
	int rv;
	
	rv = SCardTransmit(h->transp.pcsc.ctx, SCARD_PCI_T0, cmd, len, 
			   SCARD_PCI_T0, resp, &_rlen);
	if (rv != SCARD_S_SUCCESS)
		return -1;

	*rlen = _rlen;

	return 0;
}

int
mrtd_pcsc_init(struct mrtd_handle *h)
{
	h->fn.transceive = transceive_pcsc;

	return 0;
}

#endif
