#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <libmrtd/libmrtd.h>
#include <libmrtd/iso19794_5.h>

#include "../src/parse_display.h"

int test_parse_ef_com(const char *file)
{
	char buf[1024];
	int fd, len;
	u_int16_t dg_present;

	fd = open(file, O_RDONLY);
	if (fd < 0)
		return fd;

	len = read(fd, buf, sizeof(buf));
	if (len <= 0)
		return -1;

	close(fd);

	fd = parse_ef_com(buf, len, &dg_present);
	if (fd < 0)
		return fd;

	printf("0x%x\n", dg_present);
	
	return 0;
}

int test_parse_ef_dg1(const char *file)
{
	char buf[1024];
	int fd, len;

	fd = open(file, O_RDONLY);
	if (fd < 0)
		return fd;

	len = read(fd, buf, sizeof(buf));
	if (len <= 0)
		return -1;

	close(fd);

	fd = parse_ef_dg1(buf, len);
	if (fd < 0)
		return fd;

	return 0;
}

int test_parse_ef_dg2(const char *file)
{
	char buf[81920];
	int fd, len;
	struct mrtd_bio_tmpl bt;
	struct iso19794_5_info *dg2_info;
	int i;

	fd = open(file, O_RDONLY);
	if (fd < 0)
		return fd;

	len = read(fd, buf, sizeof(buf));
	if (len <= 0)
		return -1;

	close(fd);

	fd = parse_ef_dg234(buf, 2, len, &bt);
	if (fd < 0);
		return fd;

	dg2_info = iso19794_5_parse(bt.bio_data, bt.bio_data_len);
	if (!dg2_info)
		return -1;

	display_dg2(dg2_info);

	return 0;
}

int main(int argc, char **argv)
{
	if (argc > 1)
		test_parse_ef_com(argv[1]);
	if (argc > 2)
		test_parse_ef_dg1(argv[2]);
	if (argc > 3)
		test_parse_ef_dg2(argv[3]);

	exit(0);
}
